# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class CreateSubscriptionPaymentRequestEnack(BaseModel):
    """
    payment method enach.
    """
    channel: Optional[StrictStr] = Field(None, description="Channel. can be link")
    auth_mode: Optional[StrictStr] = Field(None, description="Authentication mode. can be debit_card, aadhaar, or net_banking")
    account_holder_name: Optional[StrictStr] = Field(None, description="Account holder name")
    account_number: Optional[StrictStr] = Field(None, description="Account number")
    account_bank_code: Optional[StrictStr] = Field(None, description="Account bank code (required without AccountIFSC)")
    account_type: Optional[StrictStr] = Field(None, description="Account type")
    account_ifsc: Optional[StrictStr] = Field(None, description="Account IFSC")
    __properties = ["channel", "auth_mode", "account_holder_name", "account_number", "account_bank_code", "account_type", "account_ifsc"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateSubscriptionPaymentRequestEnack:
        """Create an instance of CreateSubscriptionPaymentRequestEnack from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> CreateSubscriptionPaymentRequestEnack:
        """Create an instance of CreateSubscriptionPaymentRequestEnack from a JSON string"""
        temp_dict = json.loads(json_str)
        if "channel, auth_mode, account_holder_name, account_number, account_bank_code, account_type, account_ifsc" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateSubscriptionPaymentRequestEnack:
        """Create an instance of CreateSubscriptionPaymentRequestEnack from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateSubscriptionPaymentRequestEnack.parse_obj(obj)

        _obj = CreateSubscriptionPaymentRequestEnack.parse_obj({
            "channel": obj.get("channel"),
            "auth_mode": obj.get("auth_mode"),
            "account_holder_name": obj.get("account_holder_name"),
            "account_number": obj.get("account_number"),
            "account_bank_code": obj.get("account_bank_code"),
            "account_type": obj.get("account_type"),
            "account_ifsc": obj.get("account_ifsc")
        })
        return _obj


