# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, validator

class OrderAuthenticatePaymentRequest(BaseModel):
    """
    OTP to be submitted for headless/native OTP
    """
    otp: StrictStr = Field(..., description="OTP to be submitted")
    action: StrictStr = Field(..., description="The action for this workflow. Could be either SUBMIT_OTP or RESEND_OTP")
    __properties = ["otp", "action"]

    @validator('action')
    def action_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('SUBMIT_OTP', 'RESEND_OTP'):
            raise ValueError("must be one of enum values ('SUBMIT_OTP', 'RESEND_OTP')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderAuthenticatePaymentRequest:
        """Create an instance of OrderAuthenticatePaymentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> OrderAuthenticatePaymentRequest:
        """Create an instance of OrderAuthenticatePaymentRequest from a JSON string"""
        temp_dict = json.loads(json_str)
        if "otp, action" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderAuthenticatePaymentRequest:
        """Create an instance of OrderAuthenticatePaymentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderAuthenticatePaymentRequest.parse_obj(obj)

        _obj = OrderAuthenticatePaymentRequest.parse_obj({
            "otp": obj.get("otp"),
            "action": obj.get("action")
        })
        return _obj


