# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt, StrictStr

class OrderDetailsInDisputesEntity(BaseModel):
    """
    OrderDetailsInDisputesEntity
    """
    order_id: Optional[StrictStr] = None
    order_currency: Optional[StrictStr] = None
    order_amount: Optional[Union[StrictFloat, StrictInt]] = None
    cf_payment_id: Optional[StrictStr] = None
    payment_currency: Optional[StrictStr] = None
    payment_amount: Optional[Union[StrictFloat, StrictInt]] = None
    __properties = ["order_id", "order_currency", "order_amount", "cf_payment_id", "payment_currency", "payment_amount"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OrderDetailsInDisputesEntity:
        """Create an instance of OrderDetailsInDisputesEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> OrderDetailsInDisputesEntity:
        """Create an instance of OrderDetailsInDisputesEntity from a JSON string"""
        temp_dict = json.loads(json_str)
        if "order_id, order_currency, order_amount, cf_payment_id, payment_currency, payment_amount" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OrderDetailsInDisputesEntity:
        """Create an instance of OrderDetailsInDisputesEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OrderDetailsInDisputesEntity.parse_obj(obj)

        _obj = OrderDetailsInDisputesEntity.parse_obj({
            "order_id": obj.get("order_id"),
            "order_currency": obj.get("order_currency"),
            "order_amount": obj.get("order_amount"),
            "cf_payment_id": obj.get("cf_payment_id"),
            "payment_currency": obj.get("payment_currency"),
            "payment_amount": obj.get("payment_amount")
        })
        return _obj


