# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from cashfree_pg.models.authorization_details import AuthorizationDetails
from cashfree_pg.models.subscription_payment_entity_failure_details import SubscriptionPaymentEntityFailureDetails

class SubscriptionPaymentEntity(BaseModel):
    """
    The response returned in Get, Create or Manage Subscription Payment APIs.
    """
    authorization_details: Optional[AuthorizationDetails] = None
    cf_payment_id: Optional[StrictStr] = Field(None, description="Cashfree subscription payment reference number")
    cf_subscription_id: Optional[StrictStr] = Field(None, description="Cashfree subscription reference number")
    cf_txn_id: Optional[StrictStr] = Field(None, description="Cashfree subscription payment transaction ID")
    cf_order_id: Optional[StrictStr] = Field(None, description="Cashfree subscription payment order ID")
    failure_details: Optional[SubscriptionPaymentEntityFailureDetails] = None
    payment_amount: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The charge amount of the payment.")
    payment_id: Optional[StrictStr] = Field(None, description="A unique ID passed by merchant for identifying the transaction.")
    payment_initiated_date: Optional[StrictStr] = Field(None, description="The date on which the payment was initiated.")
    payment_remarks: Optional[StrictStr] = Field(None, description="Payment remarks.")
    payment_schedule_date: Optional[StrictStr] = Field(None, description="The date on which the payment is scheduled to be processed.")
    payment_status: Optional[StrictStr] = Field(None, description="Status of the payment.")
    payment_type: Optional[StrictStr] = Field(None, description="Payment type. Can be AUTH or CHARGE.")
    retry_attempts: Optional[StrictInt] = Field(None, description="Retry attempts.")
    subscription_id: Optional[StrictStr] = Field(None, description="A unique ID passed by merchant for identifying the subscription.")
    __properties = ["authorization_details", "cf_payment_id", "cf_subscription_id", "cf_txn_id", "cf_order_id", "failure_details", "payment_amount", "payment_id", "payment_initiated_date", "payment_remarks", "payment_schedule_date", "payment_status", "payment_type", "retry_attempts", "subscription_id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SubscriptionPaymentEntity:
        """Create an instance of SubscriptionPaymentEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> SubscriptionPaymentEntity:
        """Create an instance of SubscriptionPaymentEntity from a JSON string"""
        temp_dict = json.loads(json_str)
        if "authorization_details, cf_payment_id, cf_subscription_id, cf_txn_id, cf_order_id, failure_details, payment_amount, payment_id, payment_initiated_date, payment_remarks, payment_schedule_date, payment_status, payment_type, retry_attempts, subscription_id" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of authorization_details
        if self.authorization_details:
            _dict['authorization_details'] = self.authorization_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of failure_details
        if self.failure_details:
            _dict['failure_details'] = self.failure_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SubscriptionPaymentEntity:
        """Create an instance of SubscriptionPaymentEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SubscriptionPaymentEntity.parse_obj(obj)

        _obj = SubscriptionPaymentEntity.parse_obj({
            "authorization_details": AuthorizationDetails.from_dict(obj.get("authorization_details")) if obj.get("authorization_details") is not None else None,
            "cf_payment_id": obj.get("cf_payment_id"),
            "cf_subscription_id": obj.get("cf_subscription_id"),
            "cf_txn_id": obj.get("cf_txn_id"),
            "cf_order_id": obj.get("cf_order_id"),
            "failure_details": SubscriptionPaymentEntityFailureDetails.from_dict(obj.get("failure_details")) if obj.get("failure_details") is not None else None,
            "payment_amount": obj.get("payment_amount"),
            "payment_id": obj.get("payment_id"),
            "payment_initiated_date": obj.get("payment_initiated_date"),
            "payment_remarks": obj.get("payment_remarks"),
            "payment_schedule_date": obj.get("payment_schedule_date"),
            "payment_status": obj.get("payment_status"),
            "payment_type": obj.get("payment_type"),
            "retry_attempts": obj.get("retry_attempts"),
            "subscription_id": obj.get("subscription_id")
        })
        return _obj


