# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from cashfree_pg.models.order_delivery_status import OrderDeliveryStatus
from cashfree_pg.models.shipment_details import ShipmentDetails

class UpdateOrderExtendedDataEntity(BaseModel):
    """
    The complete update order extended data entity
    """
    cf_order_id: Optional[StrictStr] = Field(None, description="unique id generated by cashfree for your order")
    order_id: Optional[StrictStr] = Field(None, description="order_id sent during the api request")
    shipment_details: Optional[conlist(ShipmentDetails)] = None
    order_delivery_status: Optional[OrderDeliveryStatus] = None
    __properties = ["cf_order_id", "order_id", "shipment_details", "order_delivery_status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateOrderExtendedDataEntity:
        """Create an instance of UpdateOrderExtendedDataEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> UpdateOrderExtendedDataEntity:
        """Create an instance of UpdateOrderExtendedDataEntity from a JSON string"""
        temp_dict = json.loads(json_str)
        if "cf_order_id, order_id, shipment_details, order_delivery_status" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in shipment_details (list)
        _items = []
        if self.shipment_details:
            for _item in self.shipment_details:
                if _item:
                    _items.append(_item.to_dict())
            _dict['shipment_details'] = _items
        # override the default output from pydantic by calling `to_dict()` of order_delivery_status
        if self.order_delivery_status:
            _dict['order_delivery_status'] = self.order_delivery_status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateOrderExtendedDataEntity:
        """Create an instance of UpdateOrderExtendedDataEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateOrderExtendedDataEntity.parse_obj(obj)

        _obj = UpdateOrderExtendedDataEntity.parse_obj({
            "cf_order_id": obj.get("cf_order_id"),
            "order_id": obj.get("order_id"),
            "shipment_details": [ShipmentDetails.from_dict(_item) for _item in obj.get("shipment_details")] if obj.get("shipment_details") is not None else None,
            "order_delivery_status": OrderDeliveryStatus.from_dict(obj.get("order_delivery_status")) if obj.get("order_delivery_status") is not None else None
        })
        return _obj


