# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2023-08-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class VendorAdjustmentRequest(BaseModel):
    """
    Vendor Adjustment Request Body
    """
    vendor_id: StrictStr = Field(..., description="The unique identifier of the vendor to whom the adjustment is applied")
    adjustment_id: StrictInt = Field(..., description="The unique identifier for the adjustment transaction.")
    amount: Union[StrictFloat, StrictInt] = Field(..., description="The adjustment amount to be applied.")
    type: StrictStr = Field(..., description="The type of adjustment. Possible values: CREDIT, DEBIT.")
    remarks: Optional[StrictStr] = Field(None, description="Remarks for the adjustment transaction, if any.")
    __properties = ["vendor_id", "adjustment_id", "amount", "type", "remarks"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> VendorAdjustmentRequest:
        """Create an instance of VendorAdjustmentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> VendorAdjustmentRequest:
        """Create an instance of VendorAdjustmentRequest from a JSON string"""
        temp_dict = json.loads(json_str)
        if "vendor_id, adjustment_id, amount, type, remarks" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> VendorAdjustmentRequest:
        """Create an instance of VendorAdjustmentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return VendorAdjustmentRequest.parse_obj(obj)

        _obj = VendorAdjustmentRequest.parse_obj({
            "vendor_id": obj.get("vendor_id"),
            "adjustment_id": obj.get("adjustment_id"),
            "amount": obj.get("amount"),
            "type": obj.get("type"),
            "remarks": obj.get("remarks")
        })
        return _obj


